package com.ippon.error.domain;

public class ValueOverMaxException extends MyAppException {

  private ValueOverMaxException(ValueOverMaxExceptionBuilder builder) {
    super(
      MyAppException
        .builder(StandardMessage.VALUE_OVER_MAX)
        .argument("field", builder.field)
        .argument("max", builder.maxValue)
        .argument("value", builder.value)
        .message(builder.message())
        .status(ErrorStatus.INTERNAL_SERVER_ERROR)
    );
  }

  public static ValueOverMaxExceptionBuilder builder() {
    return new ValueOverMaxExceptionBuilder();
  }

  static class ValueOverMaxExceptionBuilder {
    private String field;
    private long value;
    private long maxValue;

    public ValueOverMaxExceptionBuilder field(String field) {
      this.field = field;

      return this;
    }

    public ValueOverMaxExceptionBuilder value(long value) {
      this.value = value;

      return this;
    }

    public ValueOverMaxExceptionBuilder maxValue(long maxValue) {
      this.maxValue = maxValue;

      return this;
    }

    private String message() {
      return "Value of \"" + field + "\" must be under " + maxValue + " but was " + value;
    }

    public ValueOverMaxException build() {
      return new ValueOverMaxException(this);
    }
  }
}
