package com.ippon.error.domain;

public class ValueUnderMinException extends MyAppException {

  private ValueUnderMinException(ValueUnderMinExceptionBuilder builder) {
    super(
      MyAppException
        .builder(StandardMessage.VALUE_UNDER_MIN)
        .argument("field", builder.field)
        .argument("min", builder.minValue)
        .argument("value", builder.value)
        .message(builder.message())
        .status(ErrorStatus.INTERNAL_SERVER_ERROR)
    );
  }

  public static ValueUnderMinExceptionBuilder builder() {
    return new ValueUnderMinExceptionBuilder();
  }

  static class ValueUnderMinExceptionBuilder {
    private String field;
    private long value;
    private long minValue;

    public ValueUnderMinExceptionBuilder field(String field) {
      this.field = field;

      return this;
    }

    public ValueUnderMinExceptionBuilder value(long value) {
      this.value = value;

      return this;
    }

    public ValueUnderMinExceptionBuilder minValue(long minValue) {
      this.minValue = minValue;

      return this;
    }

    private String message() {
      return "Value of \"" + field + "\" must be over " + minValue + " but was " + value;
    }

    public ValueUnderMinException build() {
      return new ValueUnderMinException(this);
    }
  }
}
