package com.ippon.pagination.domain;

import com.ippon.error.domain.ErrorStatus;
import com.ippon.error.domain.MyAppException;

class PaginationException extends MyAppException {

  private PaginationException(MyAppExceptionBuilder builder) {
    super(builder);
  }

  public static PaginationException overTenThousand() {
    return new PaginationException(
      MyAppException
        .builder(PaginationMessage.OVER_TEN_THOUSAND)
        .message("A user tried to paginate over 10 000")
        .status(ErrorStatus.BAD_REQUEST)
    );
  }
}
