package com.ippon.pagination.infrastructure.primary;

import com.ippon.error.domain.ValidationMessage;
import com.ippon.pagination.domain.MyAppPageable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import javax.validation.constraints.Max;
import javax.validation.constraints.Min;

@ApiModel(value = "MyAppPageable", description = "Pagination information")
public class RestMyAppPageable {
  @ApiModelProperty(value = "Page to display (starts at 0)", example = "0")
  private int page;

  @ApiModelProperty(value = "Number of elements on each page", example = "10")
  private int pageSize = 10;

  @Min(message = ValidationMessage.VALUE_TOO_LOW, value = 0)
  public int getPage() {
    return page;
  }

  public void setPage(int page) {
    this.page = page;
  }

  @Min(message = ValidationMessage.VALUE_TOO_LOW, value = 1)
  @Max(message = ValidationMessage.VALUE_TOO_HIGH, value = 100)
  public int getPageSize() {
    return pageSize;
  }

  public void setPageSize(int pageSize) {
    this.pageSize = pageSize;
  }

  public MyAppPageable toPageable() {
    return new MyAppPageable(page, pageSize);
  }
}
