package com.ippon.error.domain;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

class ValueUnderMinExceptionUnitTest {

  @Test
  void shouldGetExceptionInformation() {
    ValueUnderMinException exception = ValueUnderMinException.builder().field("field").value(42).minValue(51).build();

    assertThat(exception.getMessage()).contains("\"field\"").contains("42").contains("51");
    assertThat(exception.getStatus()).isEqualTo(ErrorStatus.INTERNAL_SERVER_ERROR);
    assertThat(exception.getArguments()).containsOnly(entry("field", "field"), entry("min", "51"), entry("value", "42"));
    assertThat(exception.getMyAppMessage()).isEqualTo(StandardMessage.VALUE_UNDER_MIN);
  }
}
